﻿Partial Public Class App
    Inherits Application

    ''' <summary>
    ''' Proporcionar acceso sencillo al marco raíz de la aplicación telefónica.
    ''' </summary>
    ''' <returns>Marco raíz de la aplicación telefónica.</returns>
    Public Property RootFrame As PhoneApplicationFrame

    ''' <summary>
    ''' Constructor para el objeto Application.
    ''' </summary>
    Public Sub New()
        ' Inicialización de Silverlight estándar
        InitializeComponent()

        ' Inicialización especifica del teléfono
        InitializePhoneApplication()

        ' Mostrar información de generación de perfiles gráfica durante la depuración.
        If System.Diagnostics.Debugger.IsAttached Then
            ' Mostrar los contadores de velocidad de marcos actual.
            Application.Current.Host.Settings.EnableFrameRateCounter = True

            ' Mostrar las áreas de la aplicación que se están volviendo a dibujar en cada marco.
            'Application.Current.Host.Settings.EnableRedrawRegions = True

            ' Habilitar el modo de visualización de análisis de no producción, 
            ' que muestra áreas de una página que se entregan a la GPU con una superposición coloreada.
            'Application.Current.Host.Settings.EnableCacheVisualization = True


            ' Deshabilitar la detección de inactividad de la aplicación estableciendo la propiedad UserIdleDetectionMode del
            ' objeto PhoneApplicationService de la aplicación en Disabled.
            ' Precaución: solo debe usarse en modo de depuración. Las aplicaciones que deshabiliten la detección de inactividad del usuario seguirán en ejecución
            ' y consumirán energía de la batería cuando el usuario no esté usando el teléfono.
            PhoneApplicationService.Current.UserIdleDetectionMode = IdleDetectionMode.Disabled
        End If

    End Sub

    ' Código para ejecutar cuando la aplicación se inicia (p.ej. a partir de Inicio)
    ' Este código no se ejecutará cuando la aplicación se reactive
    Private Sub Application_Launching(ByVal sender As Object, ByVal e As LaunchingEventArgs)
    End Sub

    ' Código para ejecutar cuando la aplicación se activa (se trae a primer plano)
    ' Este código no se ejecutará cuando la aplicación se inicie por primera vez
    Private Sub Application_Activated(ByVal sender As Object, ByVal e As ActivatedEventArgs)
    End Sub

    ' Código para ejecutar cuando la aplicación se desactiva (se envía a segundo plano)
    ' Este código no se ejecutará cuando la aplicación se cierre
    Private Sub Application_Deactivated(ByVal sender As Object, ByVal e As DeactivatedEventArgs)
    End Sub

    ' Código para ejecutar cuando la aplicación se cierra (p.ej., al hacer clic en Atrás)
    ' Este código no se ejecutará cuando la aplicación se desactive
    Private Sub Application_Closing(ByVal sender As Object, ByVal e As ClosingEventArgs)
    End Sub

    ' Código para ejecutar si hay un error de navegación
    Private Sub RootFrame_NavigationFailed(ByVal sender As Object, ByVal e As NavigationFailedEventArgs)
        If Diagnostics.Debugger.IsAttached Then
            ' Ha habido un error de navegación; interrumpir el depurador
            Diagnostics.Debugger.Break()
        End If
    End Sub

    Public Sub Application_UnhandledException(ByVal sender As Object, ByVal e As ApplicationUnhandledExceptionEventArgs) Handles Me.UnhandledException

        ' Mostrar información de generación de perfiles gráfica durante la depuración.
        If Diagnostics.Debugger.IsAttached Then
            Diagnostics.Debugger.Break()
        Else
            e.Handled = True
            MessageBox.Show(e.ExceptionObject.Message & Environment.NewLine & e.ExceptionObject.StackTrace,
                            "Error", MessageBoxButton.OK)
        End If
    End Sub

#Region "Inicialización de la aplicación telefónica"
    ' Evitar inicialización doble
    Private phoneApplicationInitialized As Boolean = False

    ' No agregar ningún código adicional a este método
    Private Sub InitializePhoneApplication()
        If phoneApplicationInitialized Then
            Return
        End If

        ' Crear el marco pero no establecerlo como RootVisual todavía; esto permite que
        ' la pantalla de presentación permanezca activa hasta que la aplicación esté lista para la presentación.
        RootFrame = New PhoneApplicationFrame()
        AddHandler RootFrame.Navigated, AddressOf CompleteInitializePhoneApplication

        ' Controlar errores de navegación
        AddHandler RootFrame.NavigationFailed, AddressOf RootFrame_NavigationFailed

        ' Asegurarse de que no volvemos a inicializar
        phoneApplicationInitialized = True
    End Sub

    ' No agregar ningún código adicional a este método
    Private Sub CompleteInitializePhoneApplication(ByVal sender As Object, ByVal e As NavigationEventArgs)
        ' Establecer el objeto visual raíz para permitir que la aplicación se presente
        If RootVisual IsNot RootFrame Then
            RootVisual = RootFrame
        End If

        ' Quitar este controlador porque ya no es necesario
        RemoveHandler RootFrame.Navigated, AddressOf CompleteInitializePhoneApplication
    End Sub
#End Region

End Class