﻿Imports System.IO
Imports System.Drawing
Imports GlucoGuardian.Business.Logic.Objects

Module MOD_GG_utils

    Public Function Image2Bytes(ByVal img As System.Drawing.Image) As Byte()

        Dim sTemp As String = "xxx"
        Dim fs As New FileStream(sTemp, FileMode.OpenOrCreate, FileAccess.ReadWrite)
        img.Save(fs, System.Drawing.Imaging.ImageFormat.Png)

        fs.Position = 0

        Dim imgLength As Integer = CInt(fs.Length)
        Dim bytes(0 To imgLength - 1) As Byte
        fs.Read(bytes, 0, imgLength)
        fs.Close()
        Return bytes

    End Function

    Public Function Bytes2Image(ByVal bytes() As Byte) As System.Drawing.Image

        If bytes Is Nothing Then Return Nothing
        '
        Dim ms As New MemoryStream(bytes)
        Dim bm As Bitmap = Nothing
        Try
            bm = New Bitmap(ms)
        Catch ex As Exception
            System.Diagnostics.Debug.WriteLine(ex.Message)
        End Try
        Return bm

    End Function

    Public Function HexToRgb(ByVal hex As String) As System.Windows.Media.Color

        'Convierte un valor hexadecimal en un objeto Color

        Dim a, r, g, b As Byte

        Try

            a = CByte("&H" & Mid(hex, 2, 2))
            r = CByte("&H" & Mid(hex, 4, 2))
            g = CByte("&H" & Mid(hex, 6, 2))
            b = CByte("&H" & Mid(hex, 8, 2))

            Return System.Windows.Media.Color.FromArgb(a, r, g, b)

        Catch ex As Exception

        End Try

    End Function

    Public Sub InitializePeriods(ByVal userConfig As String)

        Try

            'Carreguem la llista de períodes des de la configuració de l'usuari

            Dim counter As Integer
            counter = 0

            Main.lstPeriods.Clear()

            Dim lstTemp = Split(userConfig, "|")

            For Each period In lstTemp

                Dim obj_Period As New GG_periods

                Dim strPeriod As String = ""
                Dim strName As String = ""
                Dim strStart As String = ""
                Dim strEnd As String = ""

                strPeriod = Split(period, ";")(0)
                strName = Split(period, ";")(1)
                strStart = Split(strPeriod, "-")(0)
                strEnd = Split(strPeriod, "-")(1)

                obj_Period.PER_id_period = counter
                obj_Period.PER_name = strName
                obj_Period.PER_start_hour = strStart
                obj_Period.PER_end_hour = strEnd
                obj_Period.PER_ticks = CDate(strStart).Ticks

                Main.lstPeriods.Add(obj_Period)

                counter = counter + 1

            Next

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Public Sub InitializeRanges(ByVal userConfig As String)

        Try

            'Carreguem la llista de rangs de normalitat de la configuració de l'usuari

            Dim counter As Integer

            counter = 0

            Main.lstRanges.Clear()

            Dim lstTemp = Split(userConfig, "|")

            For Each range In lstTemp

                Dim obj_Range As New GG_ranges

                Dim strRange As String = ""
                Dim strMin As String = ""
                Dim strMax As String = ""
                Dim strColor As String = ""

                strRange = Split(range, ";")(0)
                strColor = Split(range, ";")(1)
                strMin = Split(strRange, "-")(0)
                strMax = Split(strRange, "-")(1)

                obj_Range.RAN_id_range = counter
                obj_Range.RAN_min = CInt(strMin)
                obj_Range.RAN_max = CInt(strMax)
                obj_Range.RAN_color = strColor

                Main.lstRanges.Add(obj_Range)

                counter = counter + 1

            Next

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

End Module
