﻿Class Menu

    Private Sub Menu_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        VerifyUserType()

    End Sub

    Private Sub btnHome_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnHome.Click

        'Carrega el xaml HOME en el menú principal

        ResetTabs()
        DirectCast(sender, Telerik.Windows.Controls.RadButton).FontWeight = System.Windows.FontWeights.Bold
        Main.ChangeContent("Home.xaml")

        Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Navigated to Home tab")

    End Sub

    Private Sub btnResults_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnResults.Click

        'Carrega el xaml RESULTATS en el menú principal

        ResetTabs()
        DirectCast(sender, Telerik.Windows.Controls.RadButton).FontWeight = System.Windows.FontWeights.Bold
        Main.ChangeContent("Results.xaml")

        Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Navigated to Results tab")

    End Sub

    Private Sub btnPatients_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnPatients.Click

        'Carrega el xaml PACIENTS en el menú principal

        ResetTabs()
        DirectCast(sender, Telerik.Windows.Controls.RadButton).FontWeight = System.Windows.FontWeights.Bold
        Main.ChangeContent("Patients.xaml")

        Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Navigated to Patients tab")

    End Sub

    Private Sub btnMessages_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnMessages.Click

        'Carrega el xaml MISSATGES en el menú principal

        ResetTabs()
        DirectCast(sender, Telerik.Windows.Controls.RadButton).FontWeight = System.Windows.FontWeights.Bold
        Main.ChangeContent("Messages.xaml")

        Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Navigated to Messages tab")

    End Sub

    Private Sub btnConfiguration_Click(ByVal sender As System.Object, ByVal e As System.Windows.RoutedEventArgs) Handles btnConfiguration.Click

        'Carrega el xaml CONFIGURACIÓ en el menú principal

        ResetTabs()
        DirectCast(sender, Telerik.Windows.Controls.RadButton).FontWeight = System.Windows.FontWeights.Bold
        Main.ChangeContent("Configuration.xaml")

        Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Navigated to Configuration tab")

    End Sub

    Private Sub ResetTabs()

        'Reinicia tots els tabs al seu valor original

        btnHome.FontWeight = System.Windows.FontWeights.Normal

        btnResults.FontWeight = System.Windows.FontWeights.Normal

        btnPatients.FontWeight = System.Windows.FontWeights.Normal

        btnMessages.FontWeight = System.Windows.FontWeights.Normal

        btnConfiguration.FontWeight = System.Windows.FontWeights.Normal

    End Sub

    Private Sub VerifyUserType()

        'Segons el tipus d'usuari li permetem veure unes pestanyes o altres

        Try

            Select Case Main.logedUser.USE_type

                Case Main.UserType.ADMIN.ToString

                    'L'administrador només té accés a la configuració d'usuaris i consulta de logs

                    btnConfiguration.Visibility = Windows.Visibility.Visible
                    btnHome.Visibility = Windows.Visibility.Visible
                    btnMessages.Visibility = Windows.Visibility.Collapsed
                    btnPatients.Visibility = Windows.Visibility.Collapsed
                    btnResults.Visibility = Windows.Visibility.Collapsed

                Case Main.UserType.ENDOCRINE.ToString

                    'L'endocrí té acceés a totes les pestanyes del Menú

                    btnConfiguration.Visibility = Windows.Visibility.Visible
                    btnHome.Visibility = Windows.Visibility.Visible
                    btnMessages.Visibility = Windows.Visibility.Visible
                    btnPatients.Visibility = Windows.Visibility.Visible
                    btnResults.Visibility = Windows.Visibility.Visible

                    CountMessagesNotReaded()

                Case Main.UserType.LAB.ToString

                    'El responsable del laboratori té acceés a totes les pestanyes del Menú menys a la de pacients

                    btnConfiguration.Visibility = Windows.Visibility.Visible
                    btnHome.Visibility = Windows.Visibility.Visible
                    btnMessages.Visibility = Windows.Visibility.Visible
                    btnPatients.Visibility = Windows.Visibility.Collapsed
                    btnResults.Visibility = Windows.Visibility.Visible

                    CountMessagesNotReaded()

                Case Main.UserType.MANAGER.ToString

                    'El gerent de l'hospital té accés a totes les pestanyes del Menú menys a la de pacients

                    btnConfiguration.Visibility = Windows.Visibility.Visible
                    btnHome.Visibility = Windows.Visibility.Visible
                    btnMessages.Visibility = Windows.Visibility.Visible
                    btnPatients.Visibility = Windows.Visibility.Collapsed
                    btnResults.Visibility = Windows.Visibility.Visible

                    CountMessagesNotReaded()

            End Select


        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub CountMessagesNotReaded()

        Try

            'Contem el número de missatges sense llegir que té l'usuari

            btnMessages.Content = My.Resources.Resource.msg_Messages & " (" & Main.obj_DAO.GetDestinations("USE_id_user_dest=" & Main.logedUser.USE_id_user & " AND MSD_status='RECEIVED'", "").Count & ")"

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

End Class
