﻿Imports GlucoGuardian.Business.Logic.Objects

Class Messages

    Private Sub Messages_Loaded(sender As Object, e As System.Windows.RoutedEventArgs) Handles Me.Loaded

        Try

            'Obtenim la llista de missatges que hem enviat
            griSended.ItemsSource = Main.obj_DAO.GetMessages("GG_messages.USE_id_user=" & Main.logedUser.USE_id_user, "MSG_date DESC")

            'Obtenim la llista de missatges rebuts
            griReceived.ItemsSource = Main.obj_DAO.GetDestinations("USE_id_user_dest=" & Main.logedUser.USE_id_user, "MSG_date DESC")

            'Obtenim la llista de destinataris possibles (obviem que no ens podem enviar un missatge a nosaltres mateixos)
            treDestinations.ItemsSource = Main.obj_DAO.GetUsers("USE_type NOT LIKE '%ADMIN%' AND USE_id_user <>" & Main.logedUser.USE_id_user, "")

            txtSubject.Focus()

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub btnResetMessage_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnResetMessage.Click

        Try

            'Buidem els camps d'assumpte i missatge

            txtSubject.Text = ""
            txtMessage.Text = ""

            txtChars.Content = "250"

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub btnSendMessage_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles btnSendMessage.Click

        Try

            'Registrem el missatge i tots els seus destinataris
            If txtSubject.Text <> "" And txtMessage.Text <> "" Then

                If treDestinations.CheckedItems.Count <> 0 Then

                    Dim strSubject As String = Replace(txtSubject.Text, "'", "´")
                    Dim strMessage As String = Replace(txtMessage.Text, "'", "´")

                    'Insertem el missatge
                    Main.obj_DAO.ExecuteSQL("INSERT INTO GG_messages (USE_id_user,MSG_subject,MSG_message,MSG_date) VALUES(" & Main.logedUser.USE_id_user & ",'" & strSubject & "','" & strMessage & "','" & Format(Now, "yyyyMMdd HH:mm:ss") & "')")

                    Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "New message added, subject:" & strSubject)

                    Dim MSG_id_message As Long
                    MSG_id_message = Main.obj_DAO.GetSQL("SELECT IDENT_CURRENT ('GG_messages')")

                    'Insertem cadascún dels destinataris
                    For Each user In treDestinations.CheckedItems

                        Dim obj_user As New GG_users
                        obj_user = DirectCast(user, GG_users)

                        Main.obj_DAO.ExecuteSQL("INSERT INTO GG_destinations (MSG_id_message,USE_id_user_dest,MSD_status) VALUES(" & MSG_id_message & "," & obj_user.USE_id_user & ",'RECEIVED')")

                        Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Message recipient:" & obj_user.USE_login)

                    Next

                    btnResetMessage_Click(New Object, New System.Windows.RoutedEventArgs)

                    treDestinations.ItemsSource = Main.obj_DAO.GetUsers("USE_type NOT LIKE '%ADMIN%' AND USE_id_user <>" & Main.logedUser.USE_id_user, "")

                Else

                    Main.ShowMessage(My.Resources.Resource.msg_RecipientError)

                End If

            Else

                Main.ShowMessage(My.Resources.Resource.msg_SubjectError)

            End If

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub txtDestinations_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs)

        Try

            'Al obrir el contingut d'un missatge enviat mostrem els destinataris i l'estat del missatge (RECEIVED o READED)

            Dim obj_Message As New GG_messages

            obj_Message = DirectCast(sender.Parent.Parent.Datacontext, GG_messages)

            Dim str_Destinations As String

            For Each dest In Main.obj_DAO.GetDestinations("GG_destinations.MSG_id_message=" & obj_Message.MSG_id_message, "")

                str_Destinations = str_Destinations & dest.USE_login & " -> " & dest.MSD_status & vbCrLf

            Next

            sender.Text = str_Destinations

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub txtUserFrom_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs)

        Try

            'Carreguem la informació del remitent del missatge

            Dim obj_Destination As New GG_destinations

            obj_Destination = DirectCast(sender.Parent.Parent.Datacontext, GG_destinations)

            sender.Text = Main.obj_DAO.GetMessages("MSG_id_message=" & obj_Destination.MSG_id_message, "")(0).USE_login

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub txtMessage_Loaded(sender As System.Object, e As System.Windows.RoutedEventArgs)

        Try

            'Quan obrim un missatge rebut actualitzem el seu estat a READED

            Dim obj_Destination As New GG_destinations

            obj_Destination = DirectCast(sender.Parent.Parent.Datacontext, GG_destinations)

            Main.obj_DAO.ExecuteSQL("UPDATE GG_destinations SET MSD_status='READED' WHERE MSG_id_message=" & obj_Destination.MSG_id_message & " AND USE_id_user_dest=" & obj_Destination.USE_id_user_dest)

            sender.Text = Main.obj_DAO.GetMessages("MSG_id_message=" & obj_Destination.MSG_id_message, "")(0).MSG_message

            Main.SaveLog(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, "Message readed, subject:" & obj_Destination.MSG_subject)

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

    Private Sub txtMessage_KeyDown(sender As Object, e As System.Windows.Input.KeyEventArgs) Handles txtMessage.KeyDown

        Try

            'Quan s'escriu el missatge anem restant el número de caràcters restants (màxim 250)

            Dim availableChars As Integer

            availableChars = 250 - Len(txtMessage.Text)

            If availableChars >= 0 Then

                txtChars.Content = availableChars

            End If

        Catch ex As Exception

            Main.ExceptionManagement(System.Reflection.MethodBase.GetCurrentMethod.Name.ToString, ex)

        End Try

    End Sub

End Class
