﻿Imports GlucoGuardian.Business.Logic.Objects
Imports System.Data.SqlClient
Imports System.Configuration
Imports System.Collections.ObjectModel

Public Class GG_Service
    Implements IGG_Service

    'Instrucció que permet executar INSERT, UPDATE i DELETE genèrics
    Public Function ExecuteSQL(SQL As String) As Integer Implements IGG_Service.ExecuteSQL

        Dim executionResult As Integer

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlCon.Open()
            executionResult = sqlCmd.ExecuteNonQuery()

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return executionResult

    End Function

    'Instrucció que s'encarrega de retornar un camp en concret d'una taula, també serveix per a fer COUNT
    Public Function GetSQL(SQL As String) As String Implements IGG_Service.GetSQL

        Dim strReturn As String = ""

        Dim sqlDR As SqlDataReader
        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand


        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlCon.Open()

            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()
                If IsDBNull(sqlDR(0)) <> True Then strReturn = sqlDR(0)
            End While


        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return strReturn

    End Function

    Public Function GetAnalyzers(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_analyzers) Implements IGG_Service.GetAnalyzers

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_analyzers) = New List(Of GG_analyzers)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_analyzers"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_analyzers = New GG_analyzers

                'Propietats STRING
                If IsDBNull(sqlDR("ANA_factory_number")) = True Then obj.ANA_factory_number = "" Else obj.ANA_factory_number = Trim(sqlDR("ANA_factory_number"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("ANA_id_analyzer")) = True Then obj.ANA_id_analyzer = 0 Else obj.ANA_id_analyzer = sqlDR("ANA_id_analyzer")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetConfigurations(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_configuration) Implements IGG_Service.GetConfigurations

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_configuration) = New List(Of GG_configuration)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_configuration LEFT JOIN GG_users ON (GG_configuration.USE_id_user = GG_users.USE_id_user)"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_configuration = New GG_configuration

                'Propietats STRING
                If IsDBNull(sqlDR("CFG_section")) = True Then obj.CFG_section = "" Else obj.CFG_section = Trim(sqlDR("CFG_section"))
                If IsDBNull(sqlDR("CFG_variable")) = True Then obj.CFG_variable = "" Else obj.CFG_variable = Trim(sqlDR("CFG_variable"))
                If IsDBNull(sqlDR("CFG_value")) = True Then obj.CFG_value = "" Else obj.CFG_value = Trim(sqlDR("CFG_value"))
                If IsDBNull(sqlDR("USE_login")) = True Then obj.USE_login = "" Else obj.USE_login = Trim(sqlDR("USE_login"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("CFG_id_configuration")) = True Then obj.CFG_id_configuration = 0 Else obj.CFG_id_configuration = sqlDR("CFG_id_configuration")
                If IsDBNull(sqlDR("USE_id_user")) = True Then obj.USE_id_user = 0 Else obj.USE_id_user = sqlDR("USE_id_user")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetDestinations(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_destinations) Implements IGG_Service.GetDestinations

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_destinations) = New List(Of GG_destinations)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_destinations LEFT JOIN GG_users ON (GG_destinations.USE_id_user_dest = GG_users.USE_id_user) LEFT JOIN GG_messages ON (GG_destinations.MSG_id_message = GG_messages.MSG_id_message)"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_destinations = New GG_destinations

                'Propietats STRING
                If IsDBNull(sqlDR("MSD_status")) = True Then obj.MSD_status = "" Else obj.MSD_status = Trim(sqlDR("MSD_status"))
                If IsDBNull(sqlDR("USE_login")) = True Then obj.USE_login = "" Else obj.USE_login = Trim(sqlDR("USE_login"))
                If IsDBNull(sqlDR("MSG_subject")) = True Then obj.MSG_subject = "" Else obj.MSG_subject = Trim(sqlDR("MSG_subject"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("MSG_id_message")) = True Then obj.MSG_id_message = 0 Else obj.MSG_id_message = sqlDR("MSG_id_message")
                If IsDBNull(sqlDR("USE_id_user_dest")) = True Then obj.USE_id_user_dest = 0 Else obj.USE_id_user_dest = sqlDR("USE_id_user_dest")

                'Propietats DATA
                If IsDBNull(sqlDR("MSG_date")) = True Then obj.MSG_date = Nothing Else obj.MSG_date = sqlDR("MSG_date")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetLogs(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_logs) Implements IGG_Service.GetLogs

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_logs) = New List(Of GG_logs)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_logs LEFT JOIN GG_users ON (GG_logs.USE_id_user = GG_users.USE_id_user)"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_logs = New GG_logs

                'Propietats STRING
                If IsDBNull(sqlDR("LOG_computer")) = True Then obj.LOG_computer = "" Else obj.LOG_computer = Trim(sqlDR("LOG_computer"))
                If IsDBNull(sqlDR("LOG_type")) = True Then obj.LOG_type = "" Else obj.LOG_type = Trim(sqlDR("LOG_type"))
                If IsDBNull(sqlDR("LOG_method")) = True Then obj.LOG_method = "" Else obj.LOG_method = Trim(sqlDR("LOG_method"))
                If IsDBNull(sqlDR("LOG_description")) = True Then obj.LOG_description = "" Else obj.LOG_description = Trim(sqlDR("LOG_description"))
                If IsDBNull(sqlDR("USE_login")) = True Then obj.USE_login = "" Else obj.USE_login = Trim(sqlDR("USE_login"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("LOG_id_log")) = True Then obj.LOG_id_log = 0 Else obj.LOG_id_log = sqlDR("LOG_id_log")
                If IsDBNull(sqlDR("USE_id_user")) = True Then obj.USE_id_user = 0 Else obj.USE_id_user = sqlDR("USE_id_user")

                'Propietats DATA
                If IsDBNull(sqlDR("LOG_date")) = True Then obj.LOG_date = Nothing Else obj.LOG_date = sqlDR("LOG_date")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetMessages(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_messages) Implements IGG_Service.GetMessages

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_messages) = New List(Of GG_messages)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_messages LEFT JOIN GG_users ON (GG_messages.USE_id_user = GG_users.USE_id_user)"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_messages = New GG_messages

                'Propietats STRING
                If IsDBNull(sqlDR("MSG_subject")) = True Then obj.MSG_subject = "" Else obj.MSG_subject = Trim(sqlDR("MSG_subject"))
                If IsDBNull(sqlDR("MSG_message")) = True Then obj.MSG_message = "" Else obj.MSG_message = Trim(sqlDR("MSG_message"))
                If IsDBNull(sqlDR("USE_login")) = True Then obj.USE_login = "" Else obj.USE_login = Trim(sqlDR("USE_login"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("MSG_id_message")) = True Then obj.MSG_id_message = 0 Else obj.MSG_id_message = sqlDR("MSG_id_message")
                If IsDBNull(sqlDR("USE_id_user")) = True Then obj.USE_id_user = 0 Else obj.USE_id_user = sqlDR("USE_id_user")

                'Propietats DATA
                If IsDBNull(sqlDR("MSG_date")) = True Then obj.MSG_date = Nothing Else obj.MSG_date = sqlDR("MSG_date")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetPatients(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_patients) Implements IGG_Service.GetPatients

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_patients) = New List(Of GG_patients)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_patients"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_patients = New GG_patients

                'Propietats STRING
                If IsDBNull(sqlDR("PAT_name")) = True Then obj.PAT_name = "" Else obj.PAT_name = Trim(sqlDR("PAT_name"))
                If IsDBNull(sqlDR("PAT_surname")) = True Then obj.PAT_surname = "" Else obj.PAT_surname = Trim(sqlDR("PAT_surname"))
                If IsDBNull(sqlDR("PAT_history_number")) = True Then obj.PAT_history_number = "" Else obj.PAT_history_number = Trim(sqlDR("PAT_history_number"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("PAT_id_patient")) = True Then obj.PAT_id_patient = 0 Else obj.PAT_id_patient = sqlDR("PAT_id_patient")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetResults(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GlucoGuardian.Business.Logic.Objects.GG_results) Implements IGG_Service.GetResults

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_results) = New List(Of GG_results)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_results LEFT JOIN GG_analyzers ON (GG_results.ANA_id_analyzer = GG_analyzers.ANA_id_analyzer)"
            SQL = SQL & " LEFT JOIN GG_patients ON (GG_results.PAT_id_patient = GG_patients.PAT_id_patient)"
            SQL = SQL & " LEFT JOIN GG_sections ON (GG_results.SEC_id_section = GG_sections.SEC_id_section)"
            SQL = SQL & " LEFT JOIN GG_services ON (GG_results.SER_id_service = GG_services.SER_id_service)"
            SQL = SQL & " LEFT JOIN GG_tests ON (GG_results.TES_id_test = GG_tests.TES_id_test)"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_results = New GG_results

                'Propietats STRING
                If IsDBNull(sqlDR("RES_barcode")) = True Then obj.RES_barcode = "" Else obj.RES_barcode = Trim(sqlDR("RES_barcode"))
                If IsDBNull(sqlDR("RES_control")) = True Then obj.RES_control = "" Else obj.RES_control = Trim(sqlDR("RES_control"))
                If IsDBNull(sqlDR("RES_incidence")) = True Then obj.RES_incidence = "" Else obj.RES_incidence = Trim(sqlDR("RES_incidence"))
                If IsDBNull(sqlDR("RES_level")) = True Then obj.RES_level = "" Else obj.RES_level = Trim(sqlDR("RES_level"))
                If IsDBNull(sqlDR("RES_operator")) = True Then obj.RES_operator = "" Else obj.RES_operator = Trim(sqlDR("RES_operator"))
                If IsDBNull(sqlDR("RES_reactive")) = True Then obj.RES_reactive = "" Else obj.RES_reactive = Trim(sqlDR("RES_reactive"))
                If IsDBNull(sqlDR("RES_result")) = True Then obj.RES_result = "" Else obj.RES_result = Trim(sqlDR("RES_result"))
                If IsDBNull(sqlDR("RES_type")) = True Then obj.RES_type = "" Else obj.RES_type = Trim(sqlDR("RES_type"))
                If IsDBNull(sqlDR("ANA_factory_number")) = True Then obj.ANA_factory_number = "" Else obj.ANA_factory_number = Trim(sqlDR("ANA_factory_number"))
                If IsDBNull(sqlDR("PAT_history_number")) = True Then obj.PAT_history_number = "" Else obj.PAT_history_number = Trim(sqlDR("PAT_history_number"))
                If IsDBNull(sqlDR("SEC_description")) = True Then obj.SEC_description = "" Else obj.SEC_description = Trim(sqlDR("SEC_description"))
                If IsDBNull(sqlDR("SER_description")) = True Then obj.SER_description = "" Else obj.SER_description = Trim(sqlDR("SER_description"))
                If IsDBNull(sqlDR("TES_name")) = True Then obj.TES_name = "" Else obj.TES_name = Trim(sqlDR("TES_name"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("RES_id_result")) = True Then obj.RES_id_result = 0 Else obj.RES_id_result = sqlDR("RES_id_result")
                If IsDBNull(sqlDR("res_high")) = True Then obj.RES_high = 0 Else obj.RES_high = sqlDR("res_high")
                If IsDBNull(sqlDR("RES_low")) = True Then obj.RES_low = 0 Else obj.RES_low = sqlDR("RES_low")
                If IsDBNull(sqlDR("ANA_id_analyzer")) = True Then obj.ANA_id_analyzer = 0 Else obj.ANA_id_analyzer = sqlDR("ANA_id_analyzer")
                If IsDBNull(sqlDR("PAT_id_patient")) = True Then obj.PAT_id_patient = 0 Else obj.PAT_id_patient = sqlDR("PAT_id_patient")
                If IsDBNull(sqlDR("SEC_id_section")) = True Then obj.SEC_id_section = 0 Else obj.SEC_id_section = sqlDR("SEC_id_section")
                If IsDBNull(sqlDR("SER_id_service")) = True Then obj.SER_id_service = 0 Else obj.SER_id_service = sqlDR("SER_id_service")
                If IsDBNull(sqlDR("TES_id_test")) = True Then obj.TES_id_test = 0 Else obj.TES_id_test = sqlDR("TES_id_test")

                'Propietats DATA
                Dim dat As New DateTime
                dat = sqlDR("RES_date")
                If IsDBNull(sqlDR("RES_date")) = True Then obj.RES_date = Nothing Else obj.RES_date = New DateTime(dat.Year, dat.Month, dat.Day, 0, 0, 0)
                If IsDBNull(sqlDR("RES_date")) = True Then obj.RES_hour = Nothing Else obj.RES_hour = New DateTime(Now.Year, Now.Month, Now.Day, dat.Hour, dat.Minute, dat.Second)

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetSections(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_sections) Implements IGG_Service.GetSections

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_sections) = New List(Of GG_sections)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_sections"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_sections = New GG_sections

                'Propietats STRING
                If IsDBNull(sqlDR("SEC_description")) = True Then obj.SEC_description = "" Else obj.SEC_description = Trim(sqlDR("SEC_description"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("SEC_id_section")) = True Then obj.SEC_id_section = 0 Else obj.SEC_id_section = sqlDR("SEC_id_section")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetServices(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_services) Implements IGG_Service.GetServices

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_services) = New List(Of GG_services)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_services"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_services = New GG_services

                'Propietats STRING
                If IsDBNull(sqlDR("SER_description")) = True Then obj.SER_description = "" Else obj.SER_description = Trim(sqlDR("SER_description"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("SER_id_service")) = True Then obj.SER_id_service = 0 Else obj.SER_id_service = sqlDR("SER_id_service")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetTests(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_tests) Implements IGG_Service.GetTests

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_tests) = New List(Of GG_tests)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_tests LEFT JOIN GG_units ON (GG_tests.UNI_id_units = GG_units.UNI_id_units)"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_tests = New GG_tests

                'Propietats STRING
                If IsDBNull(sqlDR("TES_name")) = True Then obj.TES_name = "" Else obj.TES_name = Trim(sqlDR("TES_name"))
                If IsDBNull(sqlDR("UNI_description")) = True Then obj.UNI_description = "" Else obj.UNI_description = Trim(sqlDR("UNI_description"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("TES_id_test")) = True Then obj.TES_id_test = 0 Else obj.TES_id_test = sqlDR("TES_id_test")
                If IsDBNull(sqlDR("UNI_id_units")) = True Then obj.UNI_id_units = 0 Else obj.UNI_id_units = sqlDR("UNI_id_units")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetUnits(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_units) Implements IGG_Service.GetUnits

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_units) = New List(Of GG_units)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_units"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_units = New GG_units

                'Propietats STRING
                If IsDBNull(sqlDR("UNI_description")) = True Then obj.UNI_description = "" Else obj.UNI_description = Trim(sqlDR("UNI_description"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("UNI_id_units")) = True Then obj.UNI_id_units = 0 Else obj.UNI_id_units = sqlDR("UNI_id_units")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function GetUsers(strCondition As String, strOrder As String) As System.Collections.Generic.IEnumerable(Of GG_users) Implements IGG_Service.GetUsers

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim sqlDR As SqlDataReader
        Dim objectsList As List(Of GG_users) = New List(Of GG_users)

        Try
            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)
            sqlCon.Open()

            'Creem la QUERY en funció dels paràmetres que passem

            SQL = "SELECT * FROM GG_users"

            If strCondition <> "" Then
                SQL = SQL & " WHERE " & strCondition
            End If
            If strOrder <> "" Then
                SQL = SQL & " ORDER BY " & strOrder
            End If

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlDR = sqlCmd.ExecuteReader

            While sqlDR.Read()

                Dim obj As GG_users = New GG_users

                'Propietats STRING
                If IsDBNull(sqlDR("USE_name")) = True Then obj.USE_name = "" Else obj.USE_name = Trim(sqlDR("USE_name"))
                If IsDBNull(sqlDR("USE_login")) = True Then obj.USE_login = "" Else obj.USE_login = Trim(sqlDR("USE_login"))
                If IsDBNull(sqlDR("USE_password")) = True Then obj.USE_password = "" Else obj.USE_password = Trim(sqlDR("USE_password"))
                If IsDBNull(sqlDR("USE_type")) = True Then obj.USE_type = "" Else obj.USE_type = Trim(sqlDR("USE_type"))

                'Propietats NUMÈRIQUES
                If IsDBNull(sqlDR("USE_id_user")) = True Then obj.USE_id_user = 0 Else obj.USE_id_user = sqlDR("USE_id_user")
                If IsDBNull(sqlDR("USE_active")) = True Then obj.USE_active = 0 Else obj.USE_active = sqlDR("USE_active")

                'Propietats ALTRES
                If IsDBNull(sqlDR("USE_logo")) = True Then obj.USE_logo = Nothing Else obj.USE_logo = sqlDR("USE_logo")

                objectsList.Add(obj)

            End While

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return objectsList

    End Function

    Public Function InsertUserLogo(ByVal obj_User As GG_users) As Integer Implements IGG_Service.InsertUserLogo

        Dim SQL As String

        Dim sqlCon As New SqlConnection
        Dim sqlCmd As New SqlCommand
        Dim executionResult As Integer

        Try

            sqlCon = New SqlConnection(ConfigurationManager.ConnectionStrings("GlucoGuardianCS").ConnectionString)


            'Montamos la SQL en función de los parámetros que pasamos a la Sub

            SQL = "UPDATE GG_users SET USE_logo=@USE_logo where USE_id_user=@USE_id_user "

            sqlCmd = New SqlCommand(SQL, sqlCon)
            sqlCon.Open()

            Dim user As SqlParameter = New SqlParameter("@USE_id_user", System.Data.SqlDbType.BigInt)
            user.Value = obj_User.USE_id_user
            sqlCmd.Parameters.Add(user)

            Dim pic As SqlParameter = New SqlParameter("@USE_logo", SqlDbType.Image)
            pic.Value = obj_User.USE_logo
            sqlCmd.Parameters.Add(pic)

            executionResult = sqlCmd.ExecuteNonQuery()

        Catch ex As Exception

            Throw ex

        Finally

            If Not sqlCon Is Nothing Then
                sqlCon.Dispose()
            End If
            If Not sqlCmd Is Nothing Then
                sqlCmd.Dispose()
            End If

        End Try

        Return executionResult

    End Function

End Class
